#include "iwopt.hh"
#include <par.h>

#include "acd_defn.hh"
#include "acd_selfdoc.h"

IOKEY IWaveInfo::iwave_iokeys[]
= {
  {"csq",    0, true,  true },
  {"data",   1, false, true },
  {"source", 1, true,  false},
  {"movie",  1, false, false},
  {"init",   1, true,  false},
  {"uc_in",  1, true, false},
  {"up_in",  2, true, false},
  {"uc_out",   1, false,  false},
  {"up_out",   2, false,  false},
  {"",       0, false, false}
};

int main(int argc, char ** argv) {

  try {

#ifdef IWAVE_USE_MPI
    int ts=0;
    MPI_Init_thread(&argc,&argv,MPI_THREAD_FUNNELED,&ts);    
#endif

    if (retrieveGlobalRank()==0 && argc<2) {
      pagedoc();
      exit(0);
    }

    TSOpt::IWaveOpApply(argc,argv,TSOpt::StraightOLS);

#ifdef IWAVE_USE_MPI
    MPI_Finalize();
#endif
  }
  catch (RVL::RVLException & e) {
    e.write(cerr);
#ifdef IWAVE_USE_MPI
    MPI_Abort(MPI_COMM_WORLD,0);
#endif
    exit(1);
  }
  
}
