/** @mainpage IWAVE Basic Utilities Package

Author: Igor Terentyev <p> Utilities used throughout IWAVE: <ul>
<li>\ref parser : "getpar" facility, interprets lists of key=value
pairs, provides functions for initialization from command line or
file, structured access </li> 

<li>\ref fopen : interface to std C i/o,
file/pointer database </li> 

<li>\ref usempi.h : uniform access to mpi
facilities - provides standard interface to MPI, also wrappers around
key MPI functions that also work in a serial environment</li> 

<li>\ref utils.h : defines constants and data types, including 

<ul> 

<li>\ref
ireal - typedef'd real datatype (used throughout in place of float or
double)</li> 

<li>\ref RARR_MAX_NDIM - max spatial dimension permitted
in this implementation</li> 

<li>\ref IPNT , \ref RPNT - spatial
integer and real coordinate vectors types</li> 

<li>\ref error</li>

</ul> </ul>

<hr>
<a href="../../../doc/html/index.html">IWAVE Home Page</a>

*/
