#ifndef __ESG_SELFDOC__
#define __ESG_SELFDOC__

const char* sdoc[]={
    "=== Finite Difference Staggered Grid Modeling of Elastic Waves in Anisotropic (up to Orthorhombic) Homogeneous Medium ===",
    "",
    "Authors: Muhong Zhou, William W. Symes.",
    "",
    "------------------------------------------------------------------------",
    "Right now this package can generate",
    "   (1) trace data at certain receiver locations (via data_vx,data_vy,data_vz); ",
    "   (2) movies (via movie_vx, movie_vy, movie_vz); ",
    "   (3) energy of the solution as a function of time (via eflag=1, data_trace), ",
    "and it also supports high order finite difference scheme (but do choose smaller ",
    "time step size if you want to use high order scheme), different grid size/length on ",
    "different grid dimensions."
    "",
    "Example: working esg scripts can be found in $IWAVE/esg/test.",
    "------------------------------------------------------------------------",
    "",
    "Executable Location: $IWAVE/esg/main/esg.x",
    "",
    "=== Input Parameters: ===",
    "   grid_info= specifies path to the buoyancy field data. This handle is used to extract grid information. In this esg package, all the medium parameter fields (buoyance, stiffness fields c11-c66) are implemented as dynamic fields to ease the domain decomposition. But IWAVE needs a static field to extract grid info, so we invent this grid_info as a static field and point it to the location of the buoyancy field. ",
    "",
    "   buoyancy= specifies path to the buoyancy field data. ",
    "",
    "   c11[, c22, ..., c66]= specifies path to the stiffness fields. Each stiffness field correponds to the location in the following stiffness matrix. ",
    "   | c11 c12 c13 0 0 0 |",
    "   | c12 c22 c23 0 0 0 |",
    "   | c13 c23 c33 0 0 0 |",
    "   | 0  0  0  c44  0 0 |",
    "   | 0  0  0  0  c55 0 |",
    "   | 0  0  0  0  0  c66|",
    "",
    "   source_vx[, source_vy, source_vz]= .su files specifie source locations for vx,vy,vz component. ",
    "",
    "   order= specifies accuracy order used by the finite difference scheme. order=n if the underlying finite difference scheme is of 2n-th order accurate. ",
    "",
    "   cfl= specifies the cfl ratio when computing the time step size. ",
    "",
    "   dt= specifies the time step size. This value will override the value computed internally using the cfl ratio. ",
    "",
    "   mpi_np1[, mpi_np2, mpi_np3]= specifies the number of domains decomposed along 1,2,3-th dimension. ",
    "",
    "   (output) data_vx[, data_vy, data_vz]= specifies paths to files (.su) containing vx,vy,vz fields as a function of time at certain (e.g., receiver) locations. ",
    "",
    "   (output) movie_vx[, movie_vy, movie_vz]= specifies paths to files (.rsf) containing vx,vy,vz fields as functions of time. ",
    "",
    "   eflag= specifies whether to compute energy of the discrete solution. ",
    "",
    "   (output) data_trace= specifies the file (.rsf) path to record the energy. This file has to be generated in advance. ",
    "",
    "------------------------------------------------------------------------",
    "=== Future Directions ===",
    "Add MPI+OpenMP, vectorization and composite grid features.",
    NULL
};

#endif

