/* 
   sgcoeffs.h
   Igor Terentyev.
   ****************************************************************************
   Coefficients for 2-2k schemes - not used anywhere, just retained for test 
   purposes
*/
/*============================================================================*/

#ifndef __SGCOEFFS_H_
#define __SGCOEFFS_H_
/*----------------------------------------------------------------------------*/

static const ireal COEFF1[] = {                   -1.0e0}; /* 2-2 */
static const ireal COEFF2[] = {             -9.0e0/8.0e0,           1.0e0/24.0e0}; /* 2-4 */
static const ireal COEFF3[] = {           -75.0e0/64.0e0,         25.0e0/384.0e0,           -3.0e0/640.0e0}; /* 2-6 */
static const ireal COEFF4[] = {       -1225.0e0/1024.0e0,       245.0e0/3072.0e0,         -49.0e0/5120.0e0,         5.0e0/7168.0e0}; /* 2-8 */
static const ireal COEFF5[] = {     -19845.0e0/16384.0e0,       735.0e0/8192.0e0,       -567.0e0/40960.0e0,     405.0e0/229376.0e0,      -35.0e0/294912.0e0}; /* 2-10*/
static const ireal COEFF6[] = {   -160083.0e0/131072.0e0,   12705.0e0/131072.0e0,   -22869.0e0/1310720.0e0,   5445.0e0/1835008.0e0,    -847.0e0/2359296.0e0,    63.0e0/2883584.0e0};  /* 2-12*/
static const ireal COEFF7[] = { -1288287.0e0/1048576.0e0, 429429.0e0/4194304.0e0, -429429.0e0/20971520.0e0, 61347.0e0/14680064.0e0, -13013.0e0/18874368.0e0, 3549.0e0/46137344.0e0, -231.0e0/54525952.0e0}; /* 2-14*/

static const ireal* SCHEME_COEFFS[7] = { COEFF1, COEFF2, COEFF3, COEFF4, COEFF5, COEFF6, COEFF7 };    
/*----------------------------------------------------------------------------*/

#endif /*__SGCOEFFS_H_*/
