  void create_fixed_2D_data(string fnm, 
			    int nt,
			    float dt,
			    float ot,
			    int nrec,
			    int ntr_in_rec,
			    float sx0,
			    float dsx,
			    float sz,
			    float rx0,
			    float drx,
			    float rz,
			    int scalel,
			    int scalco) {
			   
    string CWPROOT = getenv("CWPROOT");
    stringstream cmd;
    cmd << CWPROOT + "/bin/sunull nt=" <<nt<<" ntr="<<ntr_in_rec*nrec<<" dt="<<dt;
    cmd << "| " + CWPROOT + "/bin/sushw key=delrt a="<<ot;
    cmd << "| " + CWPROOT + "/bin/sushw key=sx a="<<sx0<<" c="<<dsx<<" j="<<ntr_in_rec;
    cmd << "| " + CWPROOT + "/bin/sushw key=selev a=" << (-1.0f)*sz;
    cmd << "| " + CWPROOT + "/bin/sushw key=gx a="<<rx0<<" b="<<drx<<" j="<<ntr_in_rec;
    cmd <<" | " + CWPROOT + "/bin/sushw key=gelev a="<<(-1.0f)*rz;
    cmd << "| " + CWPROOT + "/bin/sushw key=scalel a="<<scalel;
    cmd << "| " + CWPROOT + "/bin/sushw key=scalco a="<<scalco;
    cmd << "| " + CWPROOT + "/bin/suchw key1=offset key2=gx key3=sx b=1 c=-1 > "<<fnm<<"\n";

    if (system(cmd.str().c_str())) {
      RVLException e;
      e<<"Error: create_fixed_2D_data\n";
      e<<"  failed system call on command \n";
      e<<cmd.str();
      throw e;
    }

  }

