#include "GridSpace.hh"
#include "gtest/gtest.h"
#include "utils.h"

namespace {

  float ** alloc2d(size_t n0, size_t n1) {
    float * a1 = (float *)usermalloc_(n0*n1*sizeof(float));
    float ** a2 = (float **)usermalloc_(n1*sizeof(float*));
    for (size_t i=0; i<n1; i++) a2[i] = &(a1[n0*i]);
  }

  void dealloc2d(size_t n0, size_t n1, float ** a) {
    userfree_(&(a[0][0]));
    userfree_(a);
  }
  
  void WaveSpag(size_t n0, size_t n1,
		float d0, float d1,
		float cbulk, float cbuoy,
		int maxoff,
		int nt, int dt) {

    // allocate memory
    float ** p0 = alloc2d(n0+2*maxoff,n1+2*maxoff);
    float ** p1 = alloc2d(n0+2*maxoff,n1+2*maxoff);
    float ** v0 = alloc2d(n0+2*maxoff,n1+2*maxoff);
    float ** v1 = alloc2d(n0+2*maxoff,n1+2*maxoff);
    float ** bulk = alloc2d(n0+2*maxoff,n1+2*maxoff);
    float ** buoy = alloc2d(n0+2*maxoff,n1+2*maxoff);

    // initialize coefficients
    /* initialize scaled Courant arrays, pml layers */
    float ** coeffs = (float **)usermalloc_(2*sizeof(float*));
    for (int idim = 0; idim<2; idim++)
      (asgpars->coeffs)[idim]=NULL;
    float lam = dt/d0;
    coeffs[0] = sgcoeffs(maxoff);
    for (int i=0;i<maxoff;i++) coeffs[0][i]*=lam;
    float lam = dt/d1;
    coeffs[1] = sgcoeffs(maxoff);
    for (int i=0;i<maxoff;i++) coeffs[1][i]*=lam;

    for (int i1=0; i1<n1

    
    
  class GridTest : public ::testing::Test {
  protected:
    size_t n0;
    size_t n1;
    float o1;
    float o2;
    float d0;
    float d1;
    int id0;
    int id1;
    
    GridTest()
      : n0(10), n1(20),
	o1(0.0), o2(10.0),
	d0(20.0), d1(10.0),
	id0(0), id1(1)
    {}
  };
